wxWidgets: wxTreeEvent Class Reference

| Version: 3.2.2

Public Member Functions | List of all members
wxTreeEvent Class Reference
Class List by Category » Events

`#include <wx/treectrl.h>`

Inheritance diagram for wxTreeEvent:
[legend]

## Detailed Description

A tree event holds information about events associated with wxTreeCtrl objects.

To process input from a tree control, use these event handler macros to direct input to member functions that take a wxTreeEvent argument.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxTreeEvent& event)

Event macros:

- EVT_TREE_BEGIN_DRAG(id, func):
  Begin dragging with the left mouse button. If you want to enable left-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default. Also notice that the control must have an associated image list (see SetImageList()) to drag its items under MSW.
- EVT_TREE_BEGIN_RDRAG(id, func):
  Begin dragging with the right mouse button. If you want to enable right-dragging you need to intercept this event and explicitly call wxTreeEvent::Allow(), as it's vetoed by default.
- EVT_TREE_END_DRAG(id, func):
  End dragging with the left or right mouse button.
- EVT_TREE_BEGIN_LABEL_EDIT(id, func):
  Begin editing a label. This can be prevented by calling Veto().
- EVT_TREE_END_LABEL_EDIT(id, func):
  Finish editing a label. This can be prevented by calling Veto().
- EVT_TREE_DELETE_ITEM(id, func):
  Delete an item.
- EVT_TREE_GET_INFO(id, func):
  Request information from the application.
- EVT_TREE_SET_INFO(id, func):
  Information is being supplied.
- EVT_TREE_ITEM_ACTIVATED(id, func):
  The item has been activated, i.e. chosen by double clicking it with mouse or from keyboard.
- EVT_TREE_ITEM_COLLAPSED(id, func):
  The item has been collapsed.
- EVT_TREE_ITEM_COLLAPSING(id, func):
  The item is being collapsed. This can be prevented by calling Veto().
- EVT_TREE_ITEM_EXPANDED(id, func):
  The item has been expanded.
- EVT_TREE_ITEM_EXPANDING(id, func):
  The item is being expanded. This can be prevented by calling Veto().
- EVT_TREE_ITEM_RIGHT_CLICK(id, func):
  The user has clicked the item with the right mouse button.
- EVT_TREE_ITEM_MIDDLE_CLICK(id, func):
  The user has clicked the item with the middle mouse button.
- EVT_TREE_SEL_CHANGED(id, func):
  Selection has changed.
- EVT_TREE_SEL_CHANGING(id, func):
  Selection is changing. This can be prevented by calling Veto().
- EVT_TREE_KEY_DOWN(id, func):
  A key has been pressed.
- EVT_TREE_ITEM_GETTOOLTIP(id, func):
  The opportunity to set the item tooltip is being given to the application (call SetToolTip()). Windows only.
- EVT_TREE_ITEM_MENU(id, func):
  The context menu for the selected item has been requested, either by a right click or by using the menu key.
- EVT_TREE_STATE_IMAGE_CLICK(id, func):
  The state image has been clicked.

##

Library: wxCore
Category: Events

See also
  wxTreeCtrl

## Public Member Functions
| wxTreeEvent (wxEventType commandType, wxTreeCtrl *tree, const wxTreeItemId &item=wxTreeItemId())
| Constructor, used by wxWidgets itself only. More...
wxTreeItemId | GetItem () const
| Returns the item. More...
int | GetKeyCode () const
| Returns the key code if the event is a key event. More...
const wxKeyEvent & | GetKeyEvent () const
| Returns the key event for `EVT_TREE_KEY_DOWN` events. More...
const wxString & | GetLabel () const
| Returns the label if the event is a begin or end edit label event. More...
wxTreeItemId | GetOldItem () const
| Returns the old item index (valid for `EVT_TREE_SEL_CHANGING` and `EVT_TREE_SEL_CHANGED` events). More...
wxPoint | GetPoint () const
| Returns the position of the mouse pointer if the event is a drag or menu-context event. More...
bool | IsEditCancelled () const
| Returns true if the label edit was cancelled. More...
void | SetToolTip (const wxString &tooltip)
| Set the tooltip for the item (valid for `EVT_TREE_ITEM_GETTOOLTIP` events). More...
Public Member Functions inherited from wxNotifyEvent
| wxNotifyEvent (wxEventType eventType=wxEVT_NULL, int id=0)
| Constructor (used internally by wxWidgets only). More...
void | Allow ()
| This is the opposite of Veto(): it explicitly allows the event to be processed. More...
bool | IsAllowed () const
| Returns true if the change is allowed (Veto() hasn't been called) or false otherwise (if it was). More...
void | Veto ()
| Prevents the change announced by this event from happening. More...
Public Member Functions inherited from wxCommandEvent
| wxCommandEvent (wxEventType commandEventType=wxEVT_NULL, int id=0)
| Constructor. More...
void * | GetClientData () const
| Returns client data pointer for a listbox or choice selection event (not valid for a deselection). More...
wxClientData * | GetClientObject () const
| Returns client object pointer for a listbox or choice selection event (not valid for a deselection). More...
long | GetExtraLong () const
| Returns extra information dependent on the event objects type. More...
int | GetInt () const
| Returns the integer identifier corresponding to a listbox, choice or radiobox selection (only if the event was a selection, not a deselection), or a boolean value representing the value of a checkbox. More...
int | GetSelection () const
| Returns item index for a listbox or choice selection event (not valid for a deselection). More...
wxString | GetString () const
| Returns item string for a listbox or choice selection event. More...
bool | IsChecked () const
| This method can be used with checkbox and menu events: for the checkboxes, the method returns true for a selection event and false for a deselection one. More...
bool | IsSelection () const
| For a listbox or similar event, returns true if it is a selection, false if it is a deselection. More...
void | SetClientData (void *clientData)
| Sets the client data for this event. More...
void | SetClientObject (wxClientData *clientObject)
| Sets the client object for this event. More...
void | SetExtraLong (long extraLong)
| Sets the m_extraLong member. More...
void | SetInt (int intCommand)
| Sets the m_commandInt member. More...
void | SetString (const wxString &string)
| Sets the m_commandString member. More...
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor. More...
virtual wxEvent * | Clone () const =0
| Returns a copy of the event. More...
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any. More...
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`. More...
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event. More...
int | GetId () const
| Returns the identifier associated with this event, such as a button command id. More...
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler. More...
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise. More...
long | GetTimestamp () const
| Gets the timestamp for the event. More...
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false. More...
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation). More...
void | SetEventObject (wxObject *object)
| Sets the originating object. More...
void | SetEventType (wxEventType type)
| Sets the event type. More...
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id. More...
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event. More...
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0. More...
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns. More...
int | StopPropagation ()
| Stop the event from propagating to its parent window. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxTreeEvent()

wxTreeEvent::wxTreeEvent | ( | wxEventType | commandType,
|  | wxTreeCtrl * | tree,
|  | const wxTreeItemId & | item = `wxTreeItemId()`
| ) |  |

Constructor, used by wxWidgets itself only.

## Member Function Documentation

## ◆ GetItem()

wxTreeItemId wxTreeEvent::GetItem | ( |  | ) | const

Returns the item.

Note that the item may be invalid for wxEVT_TREE_SEL_CHANGED events when the previously selected item has been deselected and there is no new selection any longer, as it notably happens when deleting all tree control items.

## ◆ GetKeyCode()

int wxTreeEvent::GetKeyCode | ( |  | ) | const

Returns the key code if the event is a key event.

Use GetKeyEvent() to get the values of the modifier keys for this event (i.e. Shift or Ctrl).

## ◆ GetKeyEvent()

const wxKeyEvent& wxTreeEvent::GetKeyEvent | ( |  | ) | const

Returns the key event for `EVT_TREE_KEY_DOWN` events.

## ◆ GetLabel()

const wxString& wxTreeEvent::GetLabel | ( |  | ) | const

Returns the label if the event is a begin or end edit label event.

## ◆ GetOldItem()

wxTreeItemId wxTreeEvent::GetOldItem | ( |  | ) | const

Returns the old item index (valid for `EVT_TREE_SEL_CHANGING` and `EVT_TREE_SEL_CHANGED` events).

## ◆ GetPoint()

wxPoint wxTreeEvent::GetPoint | ( |  | ) | const

Returns the position of the mouse pointer if the event is a drag or menu-context event.

In both cases the position is in client coordinates - i.e. relative to the wxTreeCtrl window (so that you can pass it directly to e.g. wxWindow::PopupMenu()).

## ◆ IsEditCancelled()

bool wxTreeEvent::IsEditCancelled | ( |  | ) | const

Returns true if the label edit was cancelled.

This should be called from within an `EVT_TREE_END_LABEL_EDIT` handler.

## ◆ SetToolTip()

void wxTreeEvent::SetToolTip | ( | const wxString & | tooltip | ) |

Set the tooltip for the item (valid for `EVT_TREE_ITEM_GETTOOLTIP` events).

Windows only.